(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(factory((global.ReactPowerPlug = {}),global.React));
}(this, (function (exports,React) { 'use strict';

var React__default = 'default' in React ? React['default'] : React;

var asyncGenerator = function () {
  function AwaitValue(value) {
    this.value = value;
  }

  function AsyncGenerator(gen) {
    var front, back;

    function send(key, arg) {
      return new Promise(function (resolve, reject) {
        var request = {
          key: key,
          arg: arg,
          resolve: resolve,
          reject: reject,
          next: null
        };

        if (back) {
          back = back.next = request;
        } else {
          front = back = request;
          resume(key, arg);
        }
      });
    }

    function resume(key, arg) {
      try {
        var result = gen[key](arg);
        var value = result.value;

        if (value instanceof AwaitValue) {
          Promise.resolve(value.value).then(function (arg) {
            resume("next", arg);
          }, function (arg) {
            resume("throw", arg);
          });
        } else {
          settle(result.done ? "return" : "normal", result.value);
        }
      } catch (err) {
        settle("throw", err);
      }
    }

    function settle(type, value) {
      switch (type) {
        case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

        case "throw":
          front.reject(value);
          break;

        default:
          front.resolve({
            value: value,
            done: false
          });
          break;
      }

      front = front.next;

      if (front) {
        resume(front.key, front.arg);
      } else {
        back = null;
      }
    }

    this._invoke = send;

    if (typeof gen.return !== "function") {
      this.return = undefined;
    }
  }

  if (typeof Symbol === "function" && Symbol.asyncIterator) {
    AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
      return this;
    };
  }

  AsyncGenerator.prototype.next = function (arg) {
    return this._invoke("next", arg);
  };

  AsyncGenerator.prototype.throw = function (arg) {
    return this._invoke("throw", arg);
  };

  AsyncGenerator.prototype.return = function (arg) {
    return this._invoke("return", arg);
  };

  return {
    wrap: function (fn) {
      return function () {
        return new AsyncGenerator(fn.apply(this, arguments));
      };
    },
    await: function (value) {
      return new AwaitValue(value);
    }
  };
}();





var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var State = function (_Component) {
  inherits(State, _Component);

  function State() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, State);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = State.__proto__ || Object.getPrototypeOf(State)).call.apply(_ref, [this].concat(args))), _this), _this.state = _extends({}, _this.props.initial), _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(State, [{
    key: 'render',
    value: function render() {
      return this.props.children({
        state: this.state,
        setState: this.setState.bind(this)
      });
    }
  }]);
  return State;
}(React.Component);

State.defaultProps = {
  initial: {}
};

var defaultGetter = function defaultGetter(event) {
  return event.target.value;
};

var Bind = function Bind(_ref) {
  var children = _ref.children,
      _ref$getter = _ref.getter,
      getter = _ref$getter === undefined ? defaultGetter : _ref$getter,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? '' : _ref$initial;
  return React__default.createElement(
    State,
    { initial: { value: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;

      var setValue = function setValue() {
        return setState({ value: getter.apply(undefined, arguments) });
      };

      return children({
        value: state.value,
        setValue: setValue,
        bind: { onChange: setValue, value: state.value }
      });
    }
  );
};

var compose = function compose() {
  for (var _len = arguments.length, elements = Array(_len), _key = 0; _key < _len; _key++) {
    elements[_key] = arguments[_key];
  }

  return function (_ref) {
    var children = _ref.children;

    // Recursively stack children arguments and pass
    // it down until the last component that render children
    // with these stacked arguments
    function stackProps(i, elements) {
      var stacked = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      // check if is latest component,
      // if is latest render children,
      // otherwise continue stacking arguments
      var childrenFn = function childrenFn(props) {
        return i === 0 ? children(_extends({}, props, stacked)) : stackProps(i - 1, elements, _extends({}, props, stacked));
      };

      return React__default.cloneElement(elements[i], {}, childrenFn);
    }

    return stackProps(elements.length - 1, elements);
  };
};

var Compose = function Compose(_ref) {
  var states = _ref.states,
      children = _ref.children;
  return compose.apply(undefined, toConsumableArray(states))({ children: children });
};

var Counter = function Counter(_ref) {
  var children = _ref.children,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? 0 : _ref$initial;
  return React__default.createElement(
    State,
    { initial: { count: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;
      return children({
        count: state.count,
        inc: function inc() {
          var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
          return setState(function (s) {
            return { count: s.count + value };
          });
        },
        dec: function dec() {
          var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
          return setState(function (s) {
            return { count: s.count - value };
          });
        }
      });
    }
  );
};

var complement = function complement(fn) {
  return function () {
    return !fn.apply(undefined, arguments);
  };
};

var List = function List(_ref) {
  var children = _ref.children,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? [] : _ref$initial;
  return React__default.createElement(
    State,
    { initial: { list: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;
      return children({
        list: state.list,
        setList: function setList(list) {
          return setState({ list: list });
        },
        push: function push(value) {
          return setState({ list: state.list.push(value) });
        },
        pull: function pull(predicate) {
          return setState({ list: state.list.filter(complement(predicate)) });
        },
        sort: function sort(compareFn) {
          return setState({ list: state.list.sort(compareFn) });
        }
      });
    }
  );
};

var Set = function Set(_ref) {
  var children = _ref.children,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? {} : _ref$initial;
  return React__default.createElement(
    State,
    { initial: _extends({}, initial) },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;
      return children({
        values: state,
        set: function set$$1(key, value) {
          return setState(defineProperty({}, key, value));
        },
        over: function over(key, fn) {
          return setState(function (s) {
            return defineProperty({}, key, fn(s[key]));
          });
        },
        get: function get$$1(key) {
          return state[key];
        }
      });
    }
  );
};

var Toggle = function Toggle(_ref) {
  var children = _ref.children,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? false : _ref$initial;
  return React__default.createElement(
    State,
    { initial: { on: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;
      return children({
        on: state.on,
        off: !state.on,
        toggle: function toggle() {
          return setState(function (s) {
            return { on: !s.on };
          });
        },
        setOn: function setOn(on) {
          return setState({ on: on });
        }
      });
    }
  );
};

var index = _extends({}, exports);
delete exports.default.default;

exports.Bind = Bind;
exports.Compose = Compose;
exports.Counter = Counter;
exports.List = List;
exports.Set = Set;
exports.State = State;
exports.Toggle = Toggle;
exports.compose = compose;
exports['default'] = index;

Object.defineProperty(exports, '__esModule', { value: true });

})));
