'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _State = require('./State');

var _State2 = _interopRequireDefault(_State);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultGetter = function defaultGetter(event) {
  return event.target.value;
};

var Bind = function Bind(_ref) {
  var children = _ref.children,
      _ref$getter = _ref.getter,
      getter = _ref$getter === undefined ? defaultGetter : _ref$getter,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? '' : _ref$initial;
  return _react2.default.createElement(
    _State2.default,
    { initial: { value: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;

      var setValue = function setValue() {
        return setState({ value: getter.apply(undefined, arguments) });
      };

      return children({
        value: state.value,
        setValue: setValue,
        bind: { onChange: setValue, value: state.value }
      });
    }
  );
};

exports.default = Bind;