'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _State = require('./State');

var _State2 = _interopRequireDefault(_State);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var complement = function complement(fn) {
  return function () {
    return !fn.apply(undefined, arguments);
  };
};

var List = function List(_ref) {
  var children = _ref.children,
      _ref$initial = _ref.initial,
      initial = _ref$initial === undefined ? [] : _ref$initial;
  return _react2.default.createElement(
    _State2.default,
    { initial: { list: initial } },
    function (_ref2) {
      var state = _ref2.state,
          setState = _ref2.setState;
      return children({
        list: state.list,
        setList: function setList(list) {
          return setState({ list: list });
        },
        push: function push(value) {
          return setState({ list: state.list.push(value) });
        },
        pull: function pull(predicate) {
          return setState({ list: state.list.filter(complement(predicate)) });
        },
        sort: function sort(compareFn) {
          return setState({ list: state.list.sort(compareFn) });
        }
      });
    }
  );
};

exports.default = List;