'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var compose = function compose() {
  for (var _len = arguments.length, elements = Array(_len), _key = 0; _key < _len; _key++) {
    elements[_key] = arguments[_key];
  }

  return function (_ref) {
    var children = _ref.children;

    // Recursively stack children arguments and pass
    // it down until the last component that render children
    // with these stacked arguments
    function stackProps(i, elements) {
      var stacked = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      // check if is latest component,
      // if is latest render children,
      // otherwise continue stacking arguments
      var childrenFn = function childrenFn(props) {
        return i === 0 ? children(_extends({}, props, stacked)) : stackProps(i - 1, elements, _extends({}, props, stacked));
      };

      return _react2.default.cloneElement(elements[i], {}, childrenFn);
    }

    return stackProps(elements.length - 1, elements);
  };
};

exports.default = compose;